#ifndef _CELLSPACE_H_NOU_
#define _CELLSPACE_H_NOU_

#include <CL/cl.h>
#include <iostream>
#include <map>
#include <string>

using namespace std;

class Model;

typedef union
{
    float f;
    int i;
    unsigned int ui;
    long long l;
    unsigned long long ul;
    double d;
}Variant;

class CellSpace
{
    private:
    cl_mem space;
    int width,height;
    int which;//executiva bude prebiehat na zaklade striedania sa bufferov
    Model *parent;
    map<string, Variant> values;
    public:
    CellSpace(Model *parent, int w, int h);
    ~CellSpace();
    void run(int iteration = 1);
    Model* getParent(){ return parent; }
    cl_mem* getSpace(){ return &space; }
    int getWidth(){ return width; }
    int getHeight(){ return height; }
    void setValue(string key, Variant v);
    Variant getValue(string key);
    unsigned char* renderToTexture();
    protected:
};

#endif // _CELLSPACE_H_NOU_
