#ifndef _CELLULAMAINWINDOW_H_NOU_
#define _CELLULAMAINWINDOW_H_NOU_

#include <QMainWindow>
#include <QToolBar>
#include <QAction>
#include <QCleanlooksStyle>
#include <QMdiArea>
#include "glwidget.h"
#include "options.h"

class CellulaMainWindow : public QMainWindow
{
    Q_OBJECT
    private:
    QToolBar *main_toolbar;
    QAction *actionRun,*actionPause,*actionOpen,*actionNew,*actionQuit;
    GLwidget *gl_widget;
    Options *option_dialog;
    Machine *machine;
    QMdiArea *mdi;
    Model *model,*asyn_model;
    void createMenu();
    void createAction();
    void createToolbar();
    void translateGUI();
    public:
    CellulaMainWindow();
    ~CellulaMainWindow();
    protected:
    public slots:
    void showOptionDialog();
    void createCLMachine();
    void startSimulation();
    void stopSimulation();
    void newModel();
};

#endif // _CELLULAMAINWINDOW_H_NOU_
