#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QtOpenGL/QGLWidget>
#include <QTimer>
#include <GL/gl.h>

class CellSpace;

class GLwidget : public QGLWidget
{
    Q_OBJECT
    protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int w, int h);
    public:
    GLwidget(const QGLFormat &format, QWidget *parent = 0, CellSpace *space = NULL);
    ~GLwidget();
    void loadTexture(int w, int h, unsigned char *texture_data);
    QSize sizeHint()const{ return QSize(300, 300); }
    void mouseMoveEvent(QMouseEvent *event);
    void mousePressEvent(QMouseEvent *event);
    void wheelEvent(QWheelEvent *event);
    void startSimulation();
    void stopSimulation();
    CellSpace* getSpace(){ return space; }
    public slots:
    void runSimulation();
    private:
    GLuint tex;
    static bool initialized;
    float zoom;
    float pos_x,pos_y;
    int w,h;
    int tex_w,tex_h;
    int mouse_x,mouse_y;
    QTimer timer;
    CellSpace *space;
};

#endif // GLWIDGET_H
